package org.xiss.index;

/**
 * Entry of the structure index.
 * 
 * @author JK
 * 
 */
public interface IStructureIndexEntry extends IIndexEntry {
	/**
	 * Get ID of the name of this node (key for name table)
	 */
	public int getNameId();

	/**
	 * Get ID of the first child of this node. If this node is a leaf, the
	 * return value is {@link org.xiss.index.IIndexEntry.NONE}
	 */
	public int getFirstChildId();

	/**
	 * Get ID of the first sibling of this node. If this node is the last child
	 * of its parent, the return value is {@link #NONE}
	 */
	public int getFirstSiblingId();

	/**
	 * Get ID of the first attribute of this node. If this node has no
	 * attributes or is an attribute itself, the return value is {@link #NONE}
	 */
	public int getFirstAttributeId();
}