package org.xiss.map;

import java.io.File;

import net.sf.xanswer.storage.map.PersistentException;

import org.dbxml.core.DBException;
import org.exist.storage.store.BFile;
import org.xiss.index.impl.persistence.GenericBTree;

public class PersistentBTreeFactory<K extends Comparable<K>, V> implements
		BTreeFactory<K, V> {
	public PersistentBTreeFactory() {

	}

	public IBTree<K, V> create(String location, String name, int cacheCapacity)
			throws PersistentException {
		try {
			BFile file = new BFile(new File(location, name));
			file.drop();
			file.create();
			return new GenericBTree<K, V>(file, cacheCapacity);
		} catch (DBException e) {
			throw new PersistentException(e);
		}
	}

	public IBTree<K, V> create(String location, String name)
			throws PersistentException {
		try {
			BFile file = new BFile(new File(location, name));
			file.drop();
			file.create();
			return new GenericBTree<K, V>(file);
		} catch (DBException e) {
			throw new PersistentException(e);
		}
	}

	public IBTree<K, V> open(String location, String name, int cacheCapacity)
			throws PersistentException {
		try {
			BFile file = new BFile(new File(location, name));
			file.open();
			return new GenericBTree<K, V>(file, cacheCapacity);
		} catch (DBException e) {
			throw new PersistentException(e);
		}
	}

	public IBTree<K, V> open(String location, String name)
			throws PersistentException {
		try {
			BFile file = new BFile(new File(location, name));
			file.open();
			return new GenericBTree<K, V>(file);
		} catch (DBException e) {
			throw new PersistentException(e);
		}
	}
}
