package org.xiss.query;

import java.util.List;

import net.sf.xanswer.indexing.IndexException;

import org.xiss.index.IXissIndex;

/**
 * A query that can be ran on an index
 */
public interface IQuery {
	/**
	 * Run the query on the given index and return the result.
	 */
	IResult run(IXissIndex index) throws IndexException;

	/**
	 * Get the operations composing this query
	 */
	List<IXissOperation> getPlan();
}
