package org.xiss.query.impl;

import net.sf.xanswer.indexing.IndexException;

import org.xiss.index.IXissIndex;
import org.xiss.index.StructureIndexEntry;
import org.xiss.query.IResultNode;
import org.xml.sax.Attributes;

class NodeFromIndex implements IResultNode {
	private IXissIndex myIndex;

	private int myOrder;

	private String myName;

	private String myText;

	public NodeFromIndex(IXissIndex index, int order) {
		myIndex = index;
		myOrder = order;
	}

	public NodeFromIndex(IXissIndex index, int order, boolean isAttribute) {
		myIndex = index;
		myOrder = order;
	}

	public int getId() {
		return myOrder;
	}

	public StructureIndexEntry getStructureIndexEntry() throws IndexException {
		return myIndex.getStructureIndex().get(myOrder);
	}

	public String getNodeName() throws IndexException {
		if (myName == null) {
			myName = myIndex.getNodeName(myOrder);
		}
		return myName;
	}

	public String getNodeValue() throws IndexException {
		if (myText == null) {
			myText = myIndex.getNodeValue(myOrder);
		}
		return myText;
	}

	public Attributes getAttributes() throws IndexException {
		return new AttributesFromIndex(myIndex, myOrder);
	}
}
